#!/usr/bin/perl

require PBar;
use File::Find;
use File::Basename;
use File::Spec;
use threads;
use threads::shared;

my $os;
$os = 'unix';
$os = 'windows' if "$^O" eq "MSWin32";
my $endBar = 0;

sub rip_dvd {
	my ($driveLetter,$dvdRipToParentDir,$dvdRipTo) = @_;
	$driveLetter = trim($driveLetter);
	mkdir($dvdRipToParentDir) if !-e $dvdRipToParentDir; #paranoia
	mkdir($dvdRipTo) if !-e $dvdRipTo;
	my $colon = "";
	if("$os" eq "windows"){
		$colon = ":";
	}
	my $videoTsTmp = chopper("${driveLetter}${colon}/VIDEO_TS");
	if(-e $videoTsTmp){
		my $videoTs = "$videoTsTmp";
		my @ifofiles = ();
		opendir(VTS, $videoTs);
		@ifofiles = grep { /^VTS.*\.IFO$/ } readdir(VTS);
		closedir(VTS);
		$_ = $videoTs.'/'.$_ for @ifofiles;
		if (@ifofiles) {
			my @pgcList = pgccount(sort @ifofiles);
			#if ($advanced_mode) {
			#}
			my $can_use_threads = eval 'use threads; 1';
			if($can_use_threads){
				$endBar = 0;
				share($endBar);
				my $mplayerLoopThread = threads->create(\&mplayer_loop,$videoTs,$dvdRipTo,@pgcList);
				progress_bar($dvdRipTo, $videoTs,"vob", "VOB", 2, "Ripping DVD", "Finished Ripping", 40);
				$mplayerLoopThread->join();
			}else{
				mplayer_loop($videoTs,$dvdRipTo,@pgcList);
			}
		} else {
			cp("$videoTs/*","$dvdRipTo");
		}
	} else {
		if (-e "$driveLetter/DVD_RTAV") {
			cp("$driveLetter/DVD_RTAV/*","$dvdRipTo");
		} else {
			print("dvd video_ts not found\n");
			#&echo($lang{DVD_VIDEOTS_NOT_FOUND});
		}
	}
}

#path, newpath (both can be relative)
#/Y means overwrite (i.e. automatically say Yes to the overwrite question)
#/B means force binary copy (do not attempt to translate line endings)
#-R means recursive (copy directories and the files in them as well as just files)
sub cp {
	my ($path,$second) = @_;
	if ($os eq 'windows') {
		for (@_) {
			#COPY gives me errors unless the path delimiter is \ under doze
			s,/,\\,g if m,/,;
		}
	}
	
	$secondarg = '.';
	$secondarg = $second if $second;
	
	$command = 'cp';
	$command = 'COPY' if $os eq 'windows';
	
	$flags = ' -R';
	$flags = ' /Y /B' if $os eq 'windows';
	
	$redirect = '';
	$redirect = ' > NUL' if $os eq 'windows';
	
	$command = "${command}${flags} \"$path\" \"${secondarg}\"${redirect}";
	#for debugging
#	print $command."\n";
	system($command);
}


sub trim{ #from http://www.somacon.com/p114.php
	my ($string) = @_;
	$string =~ s/^\s+//;
	$string =~ s/\s+$//;
	return $string;
}


#give a string and it checks for "\" and removes it.
sub chopper{
	my ($string) = @_;
	if($os eq 'windows'){
		return $string;
	}else{
		my $tmp="";
		my $i=length($string)+1;
		my $not_chopped="";
		for(; ${i}>0;${i}--){
			${tmp}=chop(${string});
			if(${tmp} ne '\\'){
				${not_chopped}="${tmp}${not_chopped}";
			}
		}
		return $not_chopped;
	}
}

############################################################################
# Stand alone progress bar function
# 8 Arguments needed
# arg1 = new folder name
# arg2 = old folder/files name being copied
# arg3 = Files extension you want to use to compare(new files)
# arg4 = Files extension you want to use to compare(old files)
# arg5 = number of seconds to wait between checks
# arg6 = Message at start you want to say to user
# arg7 = Message at end you want to say to user
# arg8 = number of bars in progress bar
#
############################################################################
sub progress_bar{
	my ($newFolderName,$oldFolderName,$newFileExtCompare,
		$oldFileExtCompare,$interval,$startMessage,$endMessage,$numOfBars) = @_;
	my $pb = PBar->new( length => $numOfBars, max_num => 100 );
	print "$startMessage\n";
	my $j=0;
	$old_folder_size = $pb->get_folder_size($oldFolderName,$oldFileExtCompare);
	for(my $i=0; $i<1;){
		$j=$pb->compare_file_sizes($pb->get_folder_size($newFolderName,$newFileExtCompare),$old_folder_size);
		$pb->write_bar($j);
		if($endBar){
			$i=1;
		}elsif($j<101){
			sleep $interval;
		}else{
			$i=1;
		}
	}
	print "\n$endMessage\n";
}

# finds all unique program chains in a set of IFO files, stores in @pgclist
sub pgccount {
	my (@ifoFiles) = @_;
	use bytes;
	my $pgctable = 0x1000;
	my @pgclist = ();
	my $currentpgc = 0;
	my $buffer;
	for $ifoFile (@ifoFiles) {
        $buffer = check_ifo($ifoFile);
		next unless $buffer;
		my @sectors = ();
		for (1 .. unpack('n', substr($buffer, $pgctable, 2))) {
			$pgcstart   = unpack('N', substr($buffer, $pgctable + $_ * 8 + 4,             4));
			$cellstart  = unpack('n', substr($buffer, $pgctable + $pgcstart + 0xE8,       2)) + 8;
			$cellsector = unpack('N', substr($buffer, $pgctable + $pgcstart + $cellstart, 4));
			$currentpgc++;
			unless (grep { $_ == $cellsector } @sectors) {
				push (@sectors, $cellsector);
				push (@pgclist, "$currentpgc,$ifoFile");
			}
		}
	}
	return @pgclist;
}

# performs error checking for pgccount
sub check_ifo {
	my ($ifoFile) = @_;
	-s $ifoFile < 2**20 or return 0;
	open(IFO, '<:raw', $ifoFile) or return 0;
	local $/;
	my $buffer = <IFO>;
	close(IFO);
	substr($buffer, 0, 12) eq 'DVDVIDEO-VTS' or return 0;
	return $buffer;
}

# mplayer extraction loop, put in new thread for progress bar
# to run simultaneously with it.
sub mplayer_loop{
	my ($videoTs,$dvdRipTo,@pgcList) = @_;
	my $mplayerLoc = File::Spec->rel2abs(dirname($0));
    
	$mplayerLoc = $mplayerLoc."/mplayer";
	if($os eq 'windows'){
		$mplayerLoc = $mplayerLoc.".exe";
	}
	my $redirect = "\&>\"$dvdRipTo/mplayer.log\"";
	if($os eq 'windows'){
		$redirect = "> \"$dvdRipTo/mplayer.log\" 2>\&1";
	}
	#Rip the titles with Mplayer using info from &pgccount()
	for (@pgcList){
		m/^([^,]+),.+\/VTS_([0-9][0-9])_.*$/;
		#zero pad to 3 places to avoid sorting problems where 10 comes before 2.
		my $expandpgc = sprintf("%03d", $1);
		#FIXME log this
		system("\"$mplayerLoc\" dvd://${1} -dvd-device \"$videoTs\" -dumpstream -dumpfile \"$dvdRipTo/I${2}_${expandpgc}.vob\" $redirect");
	}
	#used to kill the progress bar just in case it doesn't kill itself first.
	$endBar=1;
}

rip_dvd($ARGV[0],$ARGV[1],$ARGV[2]);
