#!/usr/bin/perl
package PBar;
use Class::Struct length => '$', portion => '$', max_num => '$';
use List::Util qw( min );
use File::stat;
use threads;
use threads::shared;

# writes the bar based on the int argument given.
sub write_bar {
	local $| = 1;
	my ($self, $x, $max_num) = @_;
	$max_num ||= $self->max_num;
	my $old = $self->portion || 0;
	my $new_p = int( $self->length * $x / $max_num + 0.5 );

	print "\b" x( 6 + $self->length
					- min( $new_p, $old ) )
	if defined $self->portion;
	
	print "="  x( $new_p - $old ),
				" "  x ( $self->length - $new_p ),
	sprintf " %3d%% ", int( 100 * $x / $max_num + 0.5 );
	$self->portion( $new_p );
}
	
# Gets a set of files size based on the folder and ext given.
# takes two args
# arg1 = folder name containing files
# arg2 = extension to use example: vob
# returns the size in bytes
sub get_folder_size{
	my ($self,$dir, $ext) = @_;
	my $count = 0;
	opendir(DIR,$dir);
	my @dir = readdir(DIR);
	close DIR;
	foreach(@dir){
		if(m/^([^.]+)\.$ext$/) {
			$count=$count+(stat($dir."/".$_)->size);
		}
	}
	return $count;
}

# use two integer values as args to be compared
# arg1= new file being made/copied
# arg2 = file to compare to
# returns a number as a percent left to be copied.
sub compare_file_sizes{
	my $percent_left = 100;
	my ($self,$new_filesize, $old_filesize) = @_;
	if($new_filesize<$old_filesize){
		$percent_left = int(($new_filesize*100)/$old_filesize + .5);
	}else{
		$percent_left=100;
	}
	return $percent_left;
}
1;
