#!/usr/bin/perl

sub clean{
	system("rm -f ./testvid.yuv");
	system("rm -f ./testaud.fifo");
	system("rm -f ../out/test.mp4");
	system("rm -f ../out/audtest.aac");
	system("rm -f ../out/outTest.x264");
}

sub faacEncode{
	my ($videoSource,$outTo,$outBitrate,$inBitrate,$channels,$trims,$totalVideoFrames,$totalAudioFrames) = @_;
	system("mkfifo ./testaud.fifo");
	my $ameArg = "";
	if((defined $trims) && "$trims" ne ""){
		$ameArg = "\"$trims\" \"$totalVideoFrames\" \"$totalAudioFrames\"";
	}
	#print "$ameArg\n";
	system("\"../../Debug/amemiya\" \"$videoSource\" \"./testaud.fifo\" 2 $ameArg &");
	#thanks grenola
	my $faaq = "-q 65 -c 8000";
	if("$outBitrate" ge "128000"){
		$faaq = "-b 128";
	}
	if ("$outBitrate" ge "256000"){
		$faaq = "-b 256";
	}
	system("faac --mpeg-vers 4 $faaq -R $inBitrate -B 16 -X -C $channels -P ./testaud.fifo -o $outTo.aac");
	sleep(1);
	system("rm -f ./testaud.fifo");
}

#fixme
sub afconvertEncode{
	my ($videoSource,$outTo,$outBitrate,$inBitrate,$channels,$trims,$totalVideoFrames,$totalAudioFrames) = @_;
	$outBitrate = $outBitrate*1000;
	system("mkfifo ./testaud.fifo");
	my $ameArg = "";
	if((defined $trims) && "$trims" ne ""){
		$ameArg = "\"$trims\" \"$totalVideoFrames\" \"$totalAudioFrames\"";
	}
	system("\"../../Debug/amemiya\" \"$videoSource\" \"./testaud.fifo\" 2 $ameArg &");
	system("afconvert -f mp4f -d 'aac ' -b $outBitrate -s 1 -v \"./testaud.fifo\" \"$outTo.aac\"");
	system("rm -f ./testaud.fifo");
}
	
sub twoPassX264{
	my ($videoSource,$outTo,$frameRate,$bitrate,$width,$height,$trims) = @_;
	system("mkfifo ./testvid.yuv");
	system("\"../../Debug/amemiya\" \"$videoSource\" \"./testvid.yuv\" 1 \"$width\" \"$height\" \"$trims\" &");
	system("x264 --preset veryslow --crf 17 --pass 1 --slow-firstpass --no-interlaced --b-pyramid 0 --stats \"./pass1.stats\" --output \"$outTo.x264\" \"./testvid.yuv\" --fps $frameRate --input-res ${width}x$height 2>&1 | \"./tee.pl\" \"../out/x264pass1_stdout.txt\"");
	while (!(-e "./pass1.stats")) {
		print("Waiting for stats file ...\n");
		sleep(1);
	}
	system("\"../../Debug/amemiya\" \"$videoSource\" \"./testvid.yuv\" 1 \"$width\" \"$height\" \"$trims\" &");
	system("x264 --preset veryslow --bitrate $bitrate --pass 2 --no-interlaced --b-pyramid 0 --stats \"./pass1.stats\" --output \"$outTo.x264\" \"./testvid.yuv\" --fps $frameRate --input-res ${width}x$height");
	sleep(1);
	system("rm -f ./testvid.yuv");
	system("rm -f ./pass1.stat*");
}

sub ipodX264{
	my ($videoSource,$outTo,$frameRate,$bitrate,$width,$height,$trims) = @_;
	system("mkfifo ./testvid.yuv");
	system("\"../../Debug/amemiya\" \"$videoSource\" \"testvid.yuv\" 1 $width $height \"$trims\" &");
	system("x264 --profile baseline --level 1.3 --pass 1 --slow-firstpass --no-interlaced --crf 17 --stats \"./pass1.stats\" --no-cabac --ref 1 --vbv-bufsize 768 --vbv-maxrate 768 --me umh --partitions p8x8,b8x8,i4x4 --no-8x8dct --trellis 0 --output \"$outTo.x264\" \"./testvid.yuv\" --fps $frameRate --input-res ${width}x$height 2>&1 | \"./tee.pl\" \"../out/x264pass1_stdout.txt\"");
	while (!(-e "./pass1.stats")) {
		print("Waiting for stats file ...\n");
		sleep(1);
	}
	system("\"../../Debug/amemiya\" \"$videoSource\" \"testvid.yuv\" 1 $width $height \"$trims\" &");
	system("x264 --profile baseline --level 1.3 --pass 2 --no-interlaced --bitrate $bitrate --stats \"./pass1.stats\" --no-cabac --ref 1 --vbv-bufsize 768 --vbv-maxrate 768 --me umh --partitions p8x8,b8x8,i4x4 --no-8x8dct --trellis 0 --output \"$outTo.x264\" \"./testvid.yuv\" --fps $frameRate --input-res ${width}x$height");
	sleep(1);
	system("rm -f ./testvid.yuv");
	system("rm -f ./pass1.stat*");
}

sub onePassX264{
	my ($videoSource,$outTo,$frameRate,$width,$height,$crf,$trims) = @_;
	system("mkfifo ./testvid.yuv");
	system("\"../../Debug/amemiya\" \"$videoSource\" \"./testvid.yuv\" 1 $width $height \"$trims\" &");
	system("x264 --profile high --crf $crf --thread-input --b-adapt 2 --direct auto --me umh --trellis 2 --output \"$outTo.x264\" \"./testvid.yuv\" --fps $frameRate --input-res ${width}x$height");
	sleep(1);
	system("rm -f ./testvid.yuv");
}

sub ultraFastX264{#like no compression lol
	my ($videoSource,$outTo,$frameRate,$bitrate,$width,$height,$trims) = @_;
	system("mkfifo ./testvid.yuv");
	system("\"../../Debug/amemiya\" \"$videoSource\" \"./testvid.yuv\" 1 \"$width\" \"$height\" \"$trims\" &");
	system("x264 -q0 --preset ultrafast -I1 --output \"$outTo.x264\" \"./testvid.yuv\" --fps $frameRate --input-res ${width}x$height");
	sleep(1);
	system("rm -f ./testvid.yuv");
}

sub mp4box{
	my ($vid,$aud,$fps,$out) = @_;
	system("./MP4Box -fps $fps -add \"$vid\" -add \"$aud\" -new \"$out\"");
	system("rm -f $aud");
	system("rm -f $vid");
}

sub getVideoDataForEncode{
	my ($videoSource) = @_;
	if(!(-e "$videoSource.txt")){
		system("\"../../Debug/amemiya\" \"$videoSource\" \" \" 4");
	}
	my $dataFile = "$videoSource.txt";
	open(DATAFILE, "<$dataFile") or die("Could not find or open ./vidData.txt!");
	while(my $line = <DATAFILE>){
		chomp($line);
		my @dataArray = split(/=/,$line);
		$vars{"$dataArray[0]"} = "$dataArray[1]";
	}
	close(DATAFILE);
	return \%vars;
}

sub calculateAudFrame{
	my ($vidTotal,$audTotal,$frameToCalculate) = @_;
	return int($frameToCalculate*($audTotal/$vidTotal));
}
sub getAudioTrims{
	my ($vidTrimString,$totalVidFrames,$totalAudFrames) = @_;
	my $outString = "trim(";
	if($vidTrimString =~ /trim\((.*)/){
		my $numsLong = $1;
		if($numsLong =~ /([0-9]*)-([0-9]*)(.*)/){
			my $tmpn = calculateAudFrame($totalVidFrames,$totalAudFrames,$1);
			my $tmpntwo = calculateAudFrame($totalVidFrames,$totalAudFrames,$2);
			$outString = "$outString$tmpn-$tmpntwo";
			my $cont = $3;
			while("$cont" ne ")"){
				if($cont =~ /,([0-9]*)-([0-9]*)(.*)/){
					my $tmpnn = calculateAudFrame($totalVidFrames,$totalAudFrames,$1);
					if("$1" eq "0"){
						$tmpnn = 0;
					}
					my $tmpnntwo = calculateAudFrame($totalVidFrames,$totalAudFrames,$2);
					$outString = "$outString,$tmpnn-$tmpnntwo";
					$cont=$3;
				}
			}
		}
	}
	$outString = "$outString)";
	return $outString;
}

my $videoSource = "/Users/tate/Desktop/ripDisc/ripTest/rip4/I01_011.vob";
clean();
my $vidVarsRef = getVideoDataForEncode("$videoSource");
my %vidVars=%{$vidVarsRef};
my $wantedWidth = 320;
my $wantedHeight = 240;
my $actualVidWidth = $vidVars{width};
my $actualVidHeight = $vidVars{height};
my $totalVideoFrames = $vidVars{videoframes};
my $totalAudioFrames = $vidVars{audioframes};
my $trims = "trim(4900-5099)";#,4800-5499,4800-5499,4800-5499,4800-5499,4800-5499,4800-5499,4800-5499,4800-5499,4800-5499,4800-5499,4800-5499,4800-5499,4800-5499,4800-5499,4800-5499,4800-5499,4800-5499,4800-5499,4800-5499,4800-5499,4800-5499,4800-5499,4800-5499,4800-5499,4800-5499,4800-5499,4800-5499,4800-5499,4800-5499,4800-5499,4800-5499,4800-5499,4800-5499)";
my $audTrims = getAudioTrims($trims,$totalVideoFrames,$totalAudioFrames);
print "pl audio trims = $audTrims\n";
#print "max aud bitrate = $vidVars{audmaxbitrate}\n";

# low encode:
faacEncode("$videoSource","../out/audtest","64","$vidVars{audHz}","$vidVars{audChannels}",$trims,$totalVideoFrames,$totalAudioFrames);
twoPassX264("$videoSource","../out/outTest","$vidVars{fps}","128","$wantedWidth","$wantedHeight",$trims);

# ipod encode:
#faacEncode("$videoSource","../out/audtest","64","$vidVars{audHz}","$vidVars{audChannels}",$trims,$totalVideoFrames,$totalAudioFrames);
#ipodX264("$videoSource","../out/outTest","$vidVars{fps}","512","$wantedWidth","$wantedHeight",$trims);

# high encode:
#faacEncode("$videoSource","../out/audtest","256","$vidVars{audHz}","$vidVars{audChannels}",$trims,$totalVideoFrames,$totalAudioFrames);
#twoPassX264("$videoSource","../out/outTest","$vidVars{fps}","2048","$wantedWidth","$wantedHeight",$trims);

# insane encode:
#faacEncode("$videoSource","../out/audtest","$vidVars{audmaxbitrate}","$vidVars{audHz}","$vidVars{audChannels}",$trims,$totalVideoFrames,$totalAudioFrames);
#twoPassX264("$videoSource","../out/outTest","$vidVars{fps}","5000","$wantedWidth","$wantedHeight",$trims);

# extreme encode:
#faacEncode("$videoSource","../out/audtest","$vidVars{audmaxbitrate}","$vidVars{audHz}","$vidVars{audChannels}",$trims,$totalVideoFrames,$totalAudioFrames);
#twoPassX264("$videoSource","../out/outTest","$vidVars{fps}","10000","$vidVars{width}","$vidVars{height}",$trims);

# ultraFast encode:
#faacEncode("$videoSource","../out/audtest","64","$vidVars{audHz}","$vidVars{audChannels}",$trims,$totalVideoFrames,$totalAudioFrames);
#ultraFastX264("$videoSource","../out/outTest","$vidVars{fps}","0","$vidVars{width}","$vidVars{height}",$trims);

# sample output
#faacEncode("$videoSource","../out/audtest","128","$vidVars{audHz}","$vidVars{audChannels}",$trims,$totalVideoFrames,$totalAudioFrames);
#onePassX264("$videoSource","../out/outTest","$vidVars{fps}","$wantedWidth","$wantedHeight","19",$trims);

mp4box("../out/outTest.x264","../out/audtest.aac","$vidVars{fps}","../out/test.mp4");

exit(1);


#ffmpeg -pix_fmt uyvy422 -s 720×576 -f rawvideo -i output_pipe -target pal-dvd -aspect 4:3 -y myDVD.mpg