/** This file is part of amemiya.
 *
 *  amemiya is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  amemiya is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with amemiya.  If not, see <http://www.gnu.org/licenses/>.
**/

#ifndef AM_ARRAYLIST_H_
#define AM_ARRAYLIST_H_

#include <stdlib.h>
#include <stdio.h>

typedef struct AM_ArrayList_Struct *AM_ArrayList;

struct AM_ArrayList_Struct{
	int currentCapacity;
	void **data;
	int size;
};

AM_ArrayList am_newArrayList();
void am_freeList(const AM_ArrayList list);
int am_listSize(const AM_ArrayList list);
int am_listAdd(const AM_ArrayList list, void *object);
int am_listRemove(const AM_ArrayList list, const int index);
void * am_listGet(const AM_ArrayList list, const int index);
void am_listClear(const AM_ArrayList list);

#endif /* AM_ARRAYLIST_H_ */
