/** This file is part of amemiya.
 *
 *  amemiya is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  amemiya is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with amemiya.  If not, see <http://www.gnu.org/licenses/>.
**/

#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include "AM_AudioFrame.h"

static void freeAudioFrame(const AM_AudioFrame a){
	if(a!=NULL){
		free(a);
	}
}

int am_printAudioFrame(uint8_t *outbuf, int outsize, FILE *outFile){
	fwrite(outbuf,1,outsize,outFile);
	return 1;
}

AM_AudioFrame newAudioFrame(){
	AM_AudioFrame a;
	a = malloc(sizeof(struct AM_AudioFrame_Struct));
	if(a == NULL){
		fprintf(stderr, "Out of memory\n");
		fflush(stderr);
		exit(0);
	}
	a->linesize=-1;
	a->hz=-1;
	a->samplerate=-1;
	a->free=freeAudioFrame;
	return a;
}
