/** This file is part of amemiya.
 *
 *  amemiya is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  amemiya is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with amemiya.  If not, see <http://www.gnu.org/licenses/>.
**/

#ifndef AM_STRING_H_
#define AM_STRING_H_

#include <stdlib.h>
#include <stdio.h>
#include "AM_ArrayList.h"

typedef struct AM_String_Struct *AM_String;

struct AM_String_Struct{
	AM_ArrayList chars;
	void (* free)(const AM_String s);
};

AM_String am_newString();
int am_stringLength(const AM_String s);
char am_stringGetChar(const AM_String s, const int index);
char * am_stringGetChars(const AM_String s);
void am_stringAddChar(const AM_String s, const char c);
void am_stringAddChars(const AM_String s, const char *c);
int am_stringRemoveChar(const AM_String s, const int index);
int am_stringCompare(const AM_String stringOne, const AM_String stringTwo);
AM_ArrayList am_stringTokenize(const AM_String s, char delimeter);

#endif /* AM_STRING_H_ */
