/** This file is part of amemiya.
 *
 *  amemiya is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  amemiya is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with amemiya.  If not, see <http://www.gnu.org/licenses/>.
**/

#ifndef AM_TRIM_H_
#define AM_TRIM_H_

#include <stdlib.h>
#include <stdio.h>
#include "AM_ArrayList.h"
#include "AM_String.h"

typedef struct AM_Trim_Struct *AM_Trim;
struct AM_Trim_Struct{
	int64_t start;
	int64_t finish;
};

AM_Trim am_newTrim(const int64_t _start, const int64_t _finish);
int64_t am_trimTotal(const AM_Trim t);
void am_parseTrimString(const AM_ArrayList trimList, const AM_String s);
void am_freeTrim(const AM_Trim);
int am_insideTrim(const AM_Trim t, const int64_t i);
int am_atTrimEnd(const AM_Trim t, const int64_t i);
void am_printTrim(const AM_Trim t);
void am_createAudioTrims(const AM_ArrayList videoTrim, const AM_ArrayList audioTrim, const int64_t totalVideoFrames, const int64_t totalAudioFrames);

#endif /* AM_TRIM_H_ */
