/** This file is part of amemiya.
 *
 *  amemiya is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  amemiya is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with amemiya.  If not, see <http://www.gnu.org/licenses/>.
**/

#ifndef AM_VIDEOCONTEXT_H_
#define AM_VIDEOCONTEXT_H_

#include <libavcodec/avcodec.h>
#include <libavformat/avformat.h>
#include <libswscale/swscale.h>

#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <stdint.h>
#include <unistd.h>

#include "AM_ArrayList.h"
#include "AM_String.h"
#include "AM_Trim.h"
#include "AM_VideoFrame.h"

typedef struct AM_VideoContext_Struct *AM_VideoContext;
struct AM_VideoContext_Struct{
	AM_VideoFrame		v;
	int					frameFinished;
	int					stream;
	AVCodecContext  	*codecCtx;
	AVCodec         	*codec;
	AVFrame         	*frame;
	double				fps;
	int64_t				frameCount;
	int64_t				totalFrameCount;
	int					resizeBool;
	int					resizeWidth;
	int					resizeHeight;
	struct SwsContext	*sws;
	int					swsSetupBool;
	AVFrame				*resizeFrame;
	uint8_t				*buffer;
	int					numBytes;
	AM_ArrayList		trims;
	int64_t				trimIterator;
	int					videoDone;

	int 				video_crop;
	int 				topBand;             /* cropping area sizes */
	int 				leftBand;

	int					video_pad;
	int					padTop;
	int					padBottom;
	int					padLeft;
	int					padRight;
};

#endif /* AM_VIDEOCONTEXT_H_ */
