/** This file is part of amemiya.
 *
 *  amemiya is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  amemiya is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with amemiya.  If not, see <http://www.gnu.org/licenses/>.
**/

#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include "AM_VideoFrame.h"

void am_freeVideoFrame(const AM_VideoFrame v){
	if(v!=NULL){
		free(v);
	}
}

void am_printVideoFrame(const AM_VideoFrame v, FILE *of){
	int yLength = v->linesize[0];
	int uLength = v->linesize[1];
	int vLength = v->linesize[2];
	int y=0;
	for(y=0; y<v->height; y++){
        fwrite(v->data[0]+y*yLength, 1, (v->width), of);
	}
	for(y=0; y<v->height/2; y++){
		fwrite(v->data[1]+y*uLength, 1, (v->width)/2, of);
	}
	for(y=0; y<v->height/2; y++){
		fwrite(v->data[2]+y*vLength, 1, (v->width)/2, of);
	}
}


AM_VideoFrame am_newVideoFrame(){
	AM_VideoFrame v;
	v = malloc(sizeof(struct AM_VideoFrame_Struct));
	if(v == NULL){
		fprintf(stderr, "Out of memory\n");
		fflush(stderr);
		exit(0);
	}
	v->width=-1;
	v->height=-1;
	v->linesize[0]=-1;
	v->linesize[1]=-1;
	v->linesize[2]=-1;
	v->linesize[3]=-1;
	v->picType=-1;
	v->interlacedFrame=-1;
	v->topFieldFirst=-1;
	return v;
}
