/** This file is part of amemiya.
 *
 *  amemiya is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  amemiya is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with amemiya.  If not, see <http://www.gnu.org/licenses/>.
**/

#ifndef AM_VIDEOFRAME_H_
#define AM_VIDEOFRAME_H_

#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>

typedef struct AM_VideoFrame_Struct *AM_VideoFrame;

struct AM_VideoFrame_Struct{
	uint8_t *data[4];
	int linesize[4];
	int picType;
	int interlacedFrame;
	int topFieldFirst;
	int width;
	int height;
};

AM_VideoFrame am_newVideoFrame();
void am_printVideoFrame(const AM_VideoFrame v, FILE *of);
void am_freeVideoFrame(const AM_VideoFrame v);

#endif /* AM_VIDEOFRAME_H_ */
